Index: /branches/scriptimprovements/src/lib/script_engine/Makefile.am
===================================================================
--- /branches/scriptimprovements/src/lib/script_engine/Makefile.am	(revision 10615)
+++ /branches/scriptimprovements/src/lib/script_engine/Makefile.am	(revision 10616)
@@ -17,6 +17,5 @@
                 script.cc \
                 script_manager.cc \
-		executor_lua_state.cc \
-		lua_vector.cc
+		executor_lua_state.cc
 
 AM_CPPFLAGS= @LUA_INCLUDES@
@@ -28,6 +27,5 @@
 		script_class.h \
 		script_method.h \
-		executor_lua_state.h \
-		lua_vector.h
+		executor_lua_state.h
 
 
Index: anches/scriptimprovements/src/lib/script_engine/lua_vector.cc
===================================================================
--- /branches/scriptimprovements/src/lib/script_engine/lua_vector.cc	(revision 10615)
+++ 	(revision )
@@ -1,27 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   ### File Specific:
-   main-programmer: Silvan Nellen
-   co-programmer: ...
-*/
-
-#include "lua_vector.h"
-#include "script_class.h"
-
-ObjectListDefinition(LuaVector);
-
-CREATE_SCRIPTABLE_CLASS(LuaVector,
-                        addMethod("getX", Executor0ret<LuaVector, lua_State*,float>(&LuaVector::getX))
-                        ->addMethod("getY", Executor0ret<LuaVector, lua_State*,float>(&LuaVector::getY))
- 			->addMethod("getZ", Executor0ret<LuaVector, lua_State*,float>(&LuaVector::getZ))
-                      //  ->addMethod("dot", Executor1ret<LuaVector, lua_State*,float, LuaVector>(&LuaVector::dot))
-                       );
-
Index: anches/scriptimprovements/src/lib/script_engine/lua_vector.h
===================================================================
--- /branches/scriptimprovements/src/lib/script_engine/lua_vector.h	(revision 10615)
+++ 	(revision )
@@ -1,50 +1,0 @@
-/*
-   orxonox - the future of 3D-vertical-scrollers
-
-   Copyright (C) 2004 orx
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-### File Specific:
-   main-programmer: Silvan Nellen
-   co-programmer: ...
-*/
-
-/*!
- * @file lua_vector.h
- * A class derived of Vector to be used in Lua
- *
- * It does the same as Vector, but it is a BaseObject and therefore can be made scriptable.
-*/
-
-#ifndef __LUA_VECTOR_H_
-#define __LUA_VECTOR_H_
-
-
-#include "base_object.h"
-#include "vector.h"
-
-//! 3D LuaVector
-/**
-        A special class to handle 3D Vectors in Lua
-*/
-class LuaVector : public Vector, public BaseObject {
-
-//! Declare an ObjectList...
-  ObjectListDeclaration(LuaVector);
-
-public:
-  LuaVector(float x, float y, float z): Vector(z,y,z) {  this->registerObject(this, LuaVector::_objectList); }
-  LuaVector(): Vector(0,0,0) {}
- 
-  float getX(){return this->x;}
-  float getY(){return this->y;}
-  float getZ(){return this->z;}
-
-};
-
-
-#endif /* _LUA_VECTOR_H */
Index: /branches/scriptimprovements/src/world_entities/Makefile.am
===================================================================
--- /branches/scriptimprovements/src/world_entities/Makefile.am	(revision 10615)
+++ /branches/scriptimprovements/src/world_entities/Makefile.am	(revision 10616)
@@ -27,5 +27,6 @@
  		     effects/trail.cc\
 		     elements/glgui_energywidget.cc\
- 		     elements/glgui_energywidgetvertical.cc
+ 		     elements/glgui_energywidgetvertical.cc\
+		     script_triggers/script_trigger.cc
 
 
@@ -51,5 +52,6 @@
   		 effects/wobblegrid.h\
   		 elements/glgui_energywidget.h\
- 		 elements/glgui_energywidgetvertical.h
+ 		 elements/glgui_energywidgetvertical.h\
+		 script_triggers/script_trigger.h
 
 
Index: /branches/scriptimprovements/src/world_entities/WorldEntities.am
===================================================================
--- /branches/scriptimprovements/src/world_entities/WorldEntities.am	(revision 10615)
+++ /branches/scriptimprovements/src/world_entities/WorldEntities.am	(revision 10616)
@@ -102,5 +102,6 @@
                 world_entities/effects/blink.cc \
                 \
-                world_entities/script_triggers/script_trigger.cc \
+                world_entities/script_triggers/space_trigger.cc \
+		world_entities/script_triggers/tick_trigger.cc \
                 \
                 \
@@ -235,5 +236,6 @@
                 effects/blink.h \
                 \
-                script_triggers/script_trigger.h \
+                script_triggers/space_trigger.h \
+		script_triggers/tick_trigger.h \
                 \
                 \
Index: /branches/scriptimprovements/src/world_entities/script_triggers/script_trigger.h
===================================================================
--- /branches/scriptimprovements/src/world_entities/script_triggers/script_trigger.h	(revision 10615)
+++ /branches/scriptimprovements/src/world_entities/script_triggers/script_trigger.h	(revision 10616)
@@ -44,8 +44,5 @@
   private:
 
-    Script*      script;
-    std::string  functionName;
     bool         doDebugDraw;
-   
     
     //for internal use
@@ -54,5 +51,6 @@
     
   protected:
-    
+    Script*      script;
+    std::string  functionName;
     bool         scriptCalled;
     bool         scriptIsOk;
Index: /branches/scriptimprovements/src/world_entities/script_triggers/space_trigger.cc
===================================================================
--- /branches/scriptimprovements/src/world_entities/script_triggers/space_trigger.cc	(revision 10615)
+++ /branches/scriptimprovements/src/world_entities/script_triggers/space_trigger.cc	(revision 10616)
@@ -14,5 +14,5 @@
 */
 
-
+#include "util/loading/factory.h"
 #include "space_trigger.h"
 #include "debug.h"
@@ -49,5 +49,5 @@
 {
   this->registerObject(this, SpaceTrigger::_objectList);
-  this->toList(OM_COMMON);
+  //this->toList(OM_COMMON);
 
   radius = 10;
Index: /branches/scriptimprovements/src/world_entities/script_triggers/tick_trigger.cc
===================================================================
--- /branches/scriptimprovements/src/world_entities/script_triggers/tick_trigger.cc	(revision 10615)
+++ /branches/scriptimprovements/src/world_entities/script_triggers/tick_trigger.cc	(revision 10616)
@@ -14,5 +14,5 @@
 */
 
-
+#include "util/loading/factory.h"
 #include "tick_trigger.h"
 #include "debug.h"
@@ -43,5 +43,5 @@
 {
   this->registerObject(this, TickTrigger::_objectList);
-  this->toList(OM_COMMON);
+  //this->toList(OM_COMMON);
 
   if(root != NULL)