Index: code/branches/presentationFS15merge/data/defaultConfig/keybindings.ini
===================================================================
--- code/branches/presentationFS15merge/data/defaultConfig/keybindings.ini	(revision 10616)
+++ code/branches/presentationFS15merge/data/defaultConfig/keybindings.ini	(revision 10617)
@@ -142,5 +142,5 @@
 KeyWebStop=
 KeyX="selectClosest"
-KeyY=
+KeyY="onpress fire 4"
 KeyYen=
 KeyZ="selectNext"
Index: code/branches/presentationFS15merge/data/gui/scripts/presentation.lua
===================================================================
--- code/branches/presentationFS15merge/data/gui/scripts/presentation.lua	(revision 10616)
+++ code/branches/presentationFS15merge/data/gui/scripts/presentation.lua	(revision 10617)
@@ -1,19 +1,18 @@
 -- Set some test variables
-xm = 1000 
-ym = 0
-zm = 0
+x0 = 0
+y0 = 500
+z0 = 500
 
-xl = -1000 
-yl = 3000 
-zl = -1000
+xo = 2000 
+yo = 0
+zo = 0
 
-xr = 2000
-yr = 500
-zr = 2000
+x1 = 3000
+y1 = 0 
+z1 = 0
 
-d = 5
-Tabs = 0
-
-pi = 3.1415
+x2 = 2000
+y2 = 2000 
+z2 = 0
 
 -- Get a local pointer to a scriptcontroller
@@ -23,17 +22,15 @@
 if ctrl ~= nil then
 
-  ctrl:eventScheduler("mal", xl,yl,zl, xl,yl,zl, 2)
   ctrl:eventScheduler("idle", 1)
-  ctrl:eventScheduler("ral", xl, yl, zl, 3, 0, 0, math.pi)
+  ctrl:eventScheduler("chl", x0, y0, z0, xo, yo, zo, 2)
   ctrl:eventScheduler("idle", 1)
-  ctrl:eventScheduler("mal", 0,0,1000, xl,yl,zl, 3)
+  ctrl:eventScheduler("mal", x2, y2, z2, xo, yo, zo, 2)
+  ctrl:eventScheduler("mal", x1, y1, z1, xo, yo, zo, 2)
   ctrl:eventScheduler("idle", 1)
-  ctrl:eventScheduler("chl", xl, yl, zl, xr, yr, zr, 2)
+  ctrl:eventScheduler("ral", xo, yo, zo, 3, 1000, 0, 5)
   ctrl:eventScheduler("idle", 1)
-  ctrl:eventScheduler("mal", xr + 600,yr,zr, xr,yr,zr, 4)
+  ctrl:eventScheduler("ral", xo, yo, zo, 2, 1000, 0, 5)
   ctrl:eventScheduler("idle", 1)
-  ctrl:eventScheduler("chl", xr, yr, zr, xl, yl, zl, 3)
-  ctrl:eventScheduler("idle", 1)
-  ctrl:eventScheduler("spi", xm,ym,zm, 0,0,0, 4)
+  ctrl:eventScheduler("ral", xo, yo, zo, 1, 1000, 0, 5)
   ctrl:eventScheduler("idle", 1)
 
Index: code/branches/presentationFS15merge/data/gui/scripts/testscript.lua
===================================================================
--- code/branches/presentationFS15merge/data/gui/scripts/testscript.lua	(revision 10616)
+++ code/branches/presentationFS15merge/data/gui/scripts/testscript.lua	(revision 10617)
@@ -25,5 +25,5 @@
   ctrl:eventScheduler("mal", xl,yl,zl, xl,yl,zl, 2)
   ctrl:eventScheduler("idle", 1)
-  ctrl:eventScheduler("ral", xl, yl, zl, 3, 0, 0, math.pi)
+  ctrl:eventScheduler("ral", xl, yl, zl, 3, 3000, 0, math.pi)
   ctrl:eventScheduler("idle", 1)
   ctrl:eventScheduler("mal", 0,0,1000, xl,yl,zl, 3)
@@ -36,5 +36,5 @@
   ctrl:eventScheduler("idle", 1)
   ctrl:eventScheduler("spi", xm,ym,zm, 0,0,0, 4)
-  ctrl:eventScheduler("idle", 600)
+  ctrl:eventScheduler("idle", 1)
 
 end
Index: code/branches/presentationFS15merge/data/levels/clangenb.oxw
===================================================================
--- code/branches/presentationFS15merge/data/levels/clangenb.oxw	(revision 10616)
+++ code/branches/presentationFS15merge/data/levels/clangenb.oxw	(revision 10617)
@@ -1,4 +1,4 @@
 <LevelInfo
- name = "Empty level"
+ name = "clangenb"
  description = "A level with absolutely nothing in it."
  tags = "test"
Index: code/branches/presentationFS15merge/data/levels/includes/weaponSettingsFS15.oxi
===================================================================
--- code/branches/presentationFS15merge/data/levels/includes/weaponSettingsFS15.oxi	(revision 10617)
+++ code/branches/presentationFS15merge/data/levels/includes/weaponSettingsFS15.oxi	(revision 10617)
@@ -0,0 +1,51 @@
+<weaponslots>
+  <WeaponSlot position=" 0, 0, 0" />
+  <WeaponSlot position=" 0, 0, 0" />
+  <WeaponSlot position=" 0, 0, 0" />
+  <WeaponSlot position=" 0, 0, 0" />
+</weaponslots>
+<weaponsets>
+  <WeaponSet firemode=0 />
+  <WeaponSet firemode=1 />
+  <WeaponSet firemode=2 />
+  <WeaponSet firemode=3 />
+  <WeaponSet firemode=4 />
+</weaponsets>
+<weapons>
+  <WeaponPack>
+    <links>
+      <DefaultWeaponmodeLink firemode=0 weaponmode=0 />
+      <DefaultWeaponmodeLink firemode=1 weaponmode=1 />
+      <DefaultWeaponmodeLink firemode=2 weaponmode=2 />
+      <DefaultWeaponmodeLink firemode=3 weaponmode=3 />
+      <DefaultWeaponmodeLink firemode=4 weaponmode=4 />
+    </links>
+    <Weapon>
+      <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" -11.4, 0, -5" />
+      <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" -11.4, 0, -5" />
+      <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 11.4, 0, -5" />
+      <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 11.4, 0, -5" />
+    </Weapon>
+    <Weapon>
+      <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" -15, 1.6, -2" />
+      <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" -15, 1.6, -2" />
+      <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 15, 1.6, -2" />
+      <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 15, 1.6, -2" />
+    </Weapon>
+    <Weapon>
+      <LaserFire mode=1 munitionpershot=0 muzzleoffset="2.2,6,16" damage=30 shielddamage=20 />
+      <LaserFire mode=1 munitionpershot=0 muzzleoffset="-2.2,6,16" damage=30 shielddamage=20 />
+      <GravityBombFire mode=2 muzzleoffset="0,0,0" damage=30 shielddamage=20 />
+      <RocketFireOld mode=3 muzzleoffset="0,0,0" damage=30 healthdamage=50 shielddamage=20 />
+      <RocketFire mode=4 muzzleoffset="0,0,0" damage=30 healthdamage=50 shielddamage=20 />
+    </Weapon>
+  </WeaponPack>
+  <WeaponPack>
+    <links>
+      <DefaultWeaponmodeLink firemode=1 weaponmode=0 />
+    </links>
+    <!--Weapon>
+      <EnergyDrink mode=0 munitionpershot=0 delay=0  material="Flares/point_lensflare"muzzleoffset="2,-0.2,-1" />
+    </Weapon-->
+  </WeaponPack>
+</weapons>
Index: code/branches/presentationFS15merge/data/levels/includes/weaponSettingsHeartAttack.oxi
===================================================================
--- code/branches/presentationFS15merge/data/levels/includes/weaponSettingsHeartAttack.oxi	(revision 10616)
+++ code/branches/presentationFS15merge/data/levels/includes/weaponSettingsHeartAttack.oxi	(revision 10617)
@@ -35,4 +35,5 @@
           <LaserFire mode=1 munitionpershot=0 muzzleoffset="-2.2,6,16" damage=30 shielddamage=20 />
           <RocketFire mode=3 muzzleoffset="0,0,0" damage=30 healthdamage=50 shielddamage=20 />
+          <GravityBombFire mode=2 muzzleoffset="0,0,0" damage=30 shielddamage=20 />
         </Weapon>
         <Weapon>
Index: code/branches/presentationFS15merge/data/levels/includes/weaponSettingsRing.oxi
===================================================================
--- code/branches/presentationFS15merge/data/levels/includes/weaponSettingsRing.oxi	(revision 10617)
+++ code/branches/presentationFS15merge/data/levels/includes/weaponSettingsRing.oxi	(revision 10617)
@@ -0,0 +1,22 @@
+<weaponslots>
+  <WeaponSlot position="11,0,-7" />
+  <WeaponSlot position="-11,0,-7" />
+</weaponslots>
+<weaponsets>
+  <WeaponSet firemode=0 />
+  <WeaponSet firemode=1 />
+</weaponsets>
+<weapons>
+  <WeaponPack>
+    <links>
+      <DefaultWeaponmodeLink firemode=0 weaponmode=0 />
+      <DefaultWeaponmodeLink firemode=1 weaponmode=1 />
+    </links>
+    <Weapon>
+      <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=9.3 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.4,-3" projectileMesh="LaserBeam2.mesh" />
+    </Weapon>
+    <Weapon>
+      <HsW01 mode=0 munitionpershot=0 delay=0     damage=9.3 material="Flares/point_lensflare" muzzleoffset="0.1, 1.4, -3" projectileMesh="LaserBeam2.mesh" />
+    </Weapon>
+  </WeaponPack>
+</weapons>
Index: code/branches/presentationFS15merge/data/levels/presentationFS15.oxw
===================================================================
--- code/branches/presentationFS15merge/data/levels/presentationFS15.oxw	(revision 10617)
+++ code/branches/presentationFS15merge/data/levels/presentationFS15.oxw	(revision 10617)
@@ -0,0 +1,103 @@
+<LevelInfo
+ name = "Presentation FS15"
+ description = "Level for Presentation."
+ tags = "presentation"
+ screenshot = "emptylevel.png"
+/>
+
+<?lua
+  include("stats.oxo")
+  include("HUDTemplates3.oxo")
+  include("templates/lodInformation.oxt")
+?>
+
+<?lua
+  include("templates/spaceshipRing.oxt")
+  include("templates/spaceshipFS15.oxt")
+  include("templates/orbStation.oxt")
+  include("templates/spaceshipSwallow.oxt")
+?>
+
+<Level>
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+  <?lua include("includes/notifications.oxi") ?>
+
+  <Scene
+    ambientlight = "0.8, 0.8, 0.8"
+    skybox       = "Orxonox/Starbox"
+  >
+
+    <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/>
+    <SpawnPoint team=0 position="-500,0,0" lookat="-1000,0,0" spawnclass=SpaceShip pawndesign=spaceshipfs15/>
+
+    <?lua for i=0,4,1 do ?>
+      <SpaceShip position="-3000,<?lua print(i*200)?>,0" lookat="-500,0,0" visible="true">
+        <templates>
+          <Template link=spaceshipswallow />
+        </templates>
+      </SpaceShip>
+    <?lua end ?>
+
+
+    <!-- Docking  -->
+    <Dock position="-2000,0,-1000" roll=0 yaw=0 >
+      <attached>
+        <Billboard position="0,0,0" material="Alien" scale=5/>
+        <DistanceTrigger position="0,0,0" distance="200" target="Pawn" beaconMode="exclude" targetname="bcnDestroyer" name="dockMe"/>
+      </attached>
+      <animations>
+        <MoveToDockingTarget target="destroyer" />
+      </animations>
+      <effects>
+        <DockToShip target="destroyer" />
+      </effects>
+      <events>
+        <execute>
+          <EventListener event="dockMe" />
+        </execute>
+      </events>
+    </Dock>
+
+    <SpaceShip position="0,0,0" lookat="0,1000,1000" >
+      <attached>
+        <DistanceTriggerBeacon name="bcnDestroyer" />
+        <DockingTarget name="destroyer" />
+      </attached>
+      <templates>
+        <Template link=spaceshipring />
+      </templates>
+      <events>
+        <visibility>
+          <EventListener event="dockMe" />
+        </visibility>
+      </events>
+    </SpaceShip>
+
+    <MovableEntity position="2000,0,0" >
+      <templates>
+        <Template link=orbStation/>
+      </templates>
+      <events>
+        <visibility>
+          <EventListener event="dockMe" />
+        </visibility>
+      </events>
+    </MovableEntity>
+
+    <Billboard position="0,500,500" material="Flares/ringflare2" colour="0.8,0.4,0.2" scale=1 />
+    <DistanceTrigger position="0,500,500" distance="20" target="Pawn" name="takeControl"/>
+    
+    <ControllerDirector position="0,500,500" scriptname="presentation">
+      <events>
+        <takeControl>
+          <EventListener event="takeControl" />
+        </takeControl>
+      </events>
+    </ControllerDirector>
+
+
+  </Scene>
+</Level>
+
Index: code/branches/presentationFS15merge/data/levels/simone.oxw
===================================================================
--- code/branches/presentationFS15merge/data/levels/simone.oxw	(revision 10617)
+++ code/branches/presentationFS15merge/data/levels/simone.oxw	(revision 10617)
@@ -0,0 +1,37 @@
+<LevelInfo
+ name = "Simone"
+ description = "A level with absolutely nothing in it."
+ tags = "test"
+ screenshot = "emptylevel.png"
+/>
+
+<?lua
+  include("stats.oxo")
+  include("HUDTemplates3.oxo")
+  include("templates/lodInformation.oxt")
+?>
+
+<?lua
+  include("templates/spaceshipAssff2.oxt")
+  include("templates/spaceshipPirate.oxt")
+  include("templates/spaceshipRing.oxt")
+?>
+
+<Level>
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+  <?lua include("includes/notifications.oxi") ?>
+
+  <Scene
+    ambientlight = "0.8, 0.8, 0.8"
+    skybox       = "Orxonox/Starbox"
+  >
+
+    <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/>
+    <SpawnPoint team=0 position="-200,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipring />
+    <Model position="0,0,0" mesh="ship.mesh" scale="3"/>
+    
+  </Scene>
+</Level>
+
Index: code/branches/presentationFS15merge/data/levels/templates/spaceshipFS15.oxt
===================================================================
--- code/branches/presentationFS15merge/data/levels/templates/spaceshipFS15.oxt	(revision 10617)
+++ code/branches/presentationFS15merge/data/levels/templates/spaceshipFS15.oxt	(revision 10617)
@@ -0,0 +1,125 @@
+<Template name=spaceshipfs15>
+  <SpaceShip
+   hudtemplate            = spaceshiphud
+   camerapositiontemplate = spaceshipfs15cameras
+   spawnparticlesource    = "Orxonox/fairytwirl"
+   spawnparticleduration  = 3
+   explosionchunks        = 6
+
+   health            = 200
+   maxhealth         = 300
+   initialhealth     = 150
+
+   shieldhealth        = 50
+   initialshieldhealth = 50
+   maxshieldhealth     = 800
+   shieldabsorption    = 0.8
+   reloadrate          = 1
+   reloadwaittime      = 1
+
+   primaryThrust     = 40
+   auxilaryThrust    = 30
+   rotationThrust    = 35
+
+   lift = 1;
+   stallSpeed = 220;
+
+   boostPower            = 15
+   boostPowerRate        = 1
+   boostRate             = 5
+   boostCooldownDuration = 10
+
+   shakeFrequency = 15
+   shakeAmplitude = 9
+
+   collisionType     = "dynamic"
+   mass              = 100
+   linearDamping     = 0.7
+   angularDamping    = 0.9999999
+
+   explosionSound = "sounds/Explosion2.ogg"
+  >
+    <engines>
+      <MultiStateEngine position=" 7.6, 0, 19" template=spaceshipfs15engine />
+      <MultiStateEngine position="-7.6, 0, 19" template=spaceshipfs15engine />
+    </engines>
+    <attached>
+      <Model position="0,0,0" yaw=90 pitch=0 roll=0 scale=4 mesh="HeartAttack.mesh" />
+      <!--BlinkingBillboard position="17,-1.5,0" material="Examples/Flare" colour="1.0, 0.5, 0.3" amplitude=0.1 frequency=0.5 quadratic=1 />
+      <BlinkingBillboard position="-17,-1.5,0" material="Examples/Flare" colour="0.5, 1.0, 0.3" amplitude=0.1 frequency=0.5 phase=180 quadratic=1 /-->
+    </attached>
+    <collisionShapes>
+        <BoxCollisionShape position="0,0.8,6"      halfExtents="12, 3, 10" />
+        <BoxCollisionShape position="0,0.1,-11"  halfExtents="2.2, 1.8, 6" />
+  <BoxCollisionShape position="4.7,1,-8"      halfExtents="2, 3, 5" />
+  <BoxCollisionShape position="-4.7,1,-8"      halfExtents="2, 3, 5" />
+        <BoxCollisionShape position="13.5,1,5"  halfExtents="1.4, 3, 7" />
+  <BoxCollisionShape position="-13.5,1,5"  halfExtents="1.4, 3, 7" />
+  <BoxCollisionShape position="16,2,4"  halfExtents="1.4, 1.5, 4" />
+  <BoxCollisionShape position="-16,2,4"  halfExtents="1.4, 1.5, 4" />
+  <BoxCollisionShape position="-2.8,5,4"  halfExtents="1.4, 1.5, 2" />
+  <BoxCollisionShape position="2.8,5,4"  halfExtents="1.4, 1.5, 2" />
+  <BoxCollisionShape position="5,5,4.3"  halfExtents="1.4, 1.5, 1.4" />
+  <BoxCollisionShape position="-5,5,4.3"  halfExtents="1.4, 1.5, 1.4" />
+    </collisionShapes>
+<?lua
+  include("../includes/weaponSettingsFS15.oxi")
+?>
+  </SpaceShip>
+</Template>
+
+<Template name=spaceshipfs15cameras defaults=0>
+  <SpaceShip>
+    <camerapositions>
+      <CameraPosition position="0,12, 48" drag=true mouselook=true />
+      <CameraPosition position="0,20, 80" drag=true mouselook=true />
+      <CameraPosition position="0,30,120" drag=true mouselook=true />
+    </camerapositions>
+  </SpaceShip>
+</Template>
+
+<Template name=spaceshipfs15engine baseclass=MultiStateEngine>
+  <MultiStateEngine
+   boostfactor    = 2
+
+   speedfront     = 150
+   speedback      =  50
+   speedleftright =  50
+   speedupdown    =  50
+
+   defEngineSndNormal = "sounds/Engine_low.ogg"
+   defEngineSndBoost = "sounds/Engine_high.ogg"
+   
+   accelerationfront     = 420
+   accelerationbrake     = 420
+   accelerationback      =  125
+   accelerationleftright =  125
+   accelerationupdown    =  125
+  >
+    <EffectContainer condition="idle">
+      <WorldSound mainstate="activity" source="sounds/Engine_idle.ogg" looping=1 active=false/>
+    </EffectContainer>
+    <EffectContainer condition="not idle">
+      <FadingBillboard mainstate=activity active=false scale=0.1 position="4, 1.9, 19" colour="0.2, 0.65, 1.0, 1.0" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
+      <FadingBillboard mainstate=activity active=false scale=0.1 position="-4, 1.9, 19" colour="0.2, 0.65, 1.0, 1.0" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
+    </EffectContainer>
+    <EffectContainer condition="normal or brake">
+
+    </EffectContainer>
+    <EffectContainer condition="normal or boost">
+      <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 4, 1.9, 19" colour="0.6, 0.2, 0, 1.0" width=15 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
+      <Backlight mainstate=activity active=false scale=0.4 name=bltest position="-4, 1.9, 19" colour="0.6, 0.2, 0, 1.0" width=15 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
+    </EffectContainer>
+    <EffectContainer condition="boost">
+      <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 4, 1.9, 19" colour="1, 0, 0, 0.5" width=20 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
+      <Backlight mainstate=activity active=false scale=0.4 name=bltest position="-4, 1.9, 19" colour="1, 0, 0, 1" width=20 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
+    </EffectContainer>
+   <EffectContainer condition="brake">
+      <FadingBillboard mainstate=activity active=false scale=0.3 position=" 4, 1.9, 19" colour="0.5, 0.0, 0.0, 0.3" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
+      <FadingBillboard mainstate=activity active=false scale=0.3 position="-4, 1.9, 19" colour="0.5, 0.0, 0.0, 0.3" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
+      <FadingBillboard mainstate=activity active=false scale=0.15 position=" 4, 1.9, 19" colour="1.0, 0.0, 0.0, 1.0" material="Flares/backlightflare" turnontime=0.5 turnofftime=0.5 />
+      <FadingBillboard mainstate=activity active=false scale=0.15 position="-4, 1.9, 19" colour="1.0, 0.0, 0.0, 1.0" material="Flares/backlightflare" turnontime=0.5 turnofftime=0.5 />
+    </EffectContainer>
+
+  </MultiStateEngine>
+</Template>
Index: code/branches/presentationFS15merge/data/levels/templates/spaceshipHeartAttack.oxt
===================================================================
--- code/branches/presentationFS15merge/data/levels/templates/spaceshipHeartAttack.oxt	(revision 10616)
+++ code/branches/presentationFS15merge/data/levels/templates/spaceshipHeartAttack.oxt	(revision 10617)
@@ -2,5 +2,5 @@
   <SpaceShip
    hudtemplate            = spaceshiphud
-   camerapositiontemplate = spaceshipassffcameras
+   camerapositiontemplate = spaceshipheartattackcameras
    spawnparticlesource    = "Orxonox/fairytwirl"
    spawnparticleduration  = 3
@@ -69,8 +69,8 @@
 </Template>
 
-<Template name=spaceshipassffcameras defaults=0>
+<Template name=spaceshipheartattackcameras defaults=0>
   <SpaceShip>
     <camerapositions>
-      <CameraPosition position="0,10, 40" drag=true mouselook=true />
+      <CameraPosition position="0,12, 48" drag=true mouselook=true />
       <CameraPosition position="0,20, 80" drag=true mouselook=true />
       <CameraPosition position="0,30,120" drag=true mouselook=true />
Index: code/branches/presentationFS15merge/data/levels/templates/spaceshipRing.oxt
===================================================================
--- code/branches/presentationFS15merge/data/levels/templates/spaceshipRing.oxt	(revision 10617)
+++ code/branches/presentationFS15merge/data/levels/templates/spaceshipRing.oxt	(revision 10617)
@@ -0,0 +1,110 @@
+<Template name=spaceshipring>
+  <SpaceShip
+   hudtemplate            = spaceshiphud
+   camerapositiontemplate = spaceshipringcameras
+   spawnparticlesource    = "Orxonox/fairytwirl"
+   spawnparticleduration  = 3
+   explosionchunks        = 4
+
+   health            = 80
+   maxhealth         = 200
+   initialhealth     = 80
+
+   shieldhealth        = 35
+   initialshieldhealth = 35
+   maxshieldhealth     = 60
+   shieldabsorption    = 0.9
+   reloadrate          = 1
+   reloadwaittime      = 1
+
+   primaryThrust     = 150
+   auxilaryThrust    = 30
+   rotationThrust    = 50
+
+   lift = 1;
+   stallSpeed = 220;
+
+   boostPower            = 20
+   boostPowerRate        = 1
+   boostRate             = 5
+   boostCooldownDuration = 10
+
+   shakeFrequency = 15
+   shakeAmplitude = 6
+
+   collisionType     = "dynamic"
+   mass              = 80
+   linearDamping     = 0.7
+   angularDamping    = 0.9999999
+  >
+    <engines>
+      <MultiStateEngine position=" 7.6, 0, 0" template=spaceshipringengine />
+      <MultiStateEngine position="-7.6, 0, 0" template=spaceshipringengine />
+    </engines>
+    <attached>
+      <Model position="0,0,0" yaw=90 pitch=0 roll=0 scale=4 mesh="ship.mesh" />
+      <Model position="11,1,-9" yaw=-90 pitch=0 roll=90 scale=0.15 mesh="ringWeapon.mesh" />
+      <Model position="-11,1,-9" yaw=-90 pitch=0 roll=90 scale=0.15 mesh="ringWeapon.mesh" />
+    </attached>
+    <collisionShapes>
+      <BoxCollisionShape position="0    ,0 ,  3" halfExtents="10,   4,8" />
+      <BoxCollisionShape position="12.6 ,-2,  3" halfExtents="2.8,2.8,11"/>
+      <BoxCollisionShape position="-12.6,-2,  3" halfExtents="2.8,2.8,11"/>
+      <BoxCollisionShape position="0,     0,-12" halfExtents="4  , 4 ,7" />
+    </collisionShapes>
+<?lua
+  include("../includes/weaponSettingsRing.oxi")
+?>
+  </SpaceShip>
+</Template>
+
+<Template name=spaceshipringcameras defaults=0>
+  <SpaceShip>
+    <camerapositions>
+      <CameraPosition position="0,15, 60" drag=true mouselook=true />
+      <CameraPosition position="0,20, 90" drag=true mouselook=true />
+      <CameraPosition position="0,30,120" drag=true mouselook=true />
+    </camerapositions>
+  </SpaceShip>
+</Template>
+
+<Template name=spaceshipringengine baseclass=MultiStateEngine>
+  <MultiStateEngine
+   boostfactor    = 2.2
+
+   speedfront     = 200
+   speedback      =  70
+   speedleftright =  70
+   speedupdown    =  70
+
+   defEngineSndNormal = "sounds/Engine_low.ogg"
+   defEngineSndBoost = "sounds/Engine_high.ogg"
+
+   accelerationfront     = 700
+   accelerationbrake     = 700
+   accelerationback      =  125
+   accelerationleftright =  125
+   accelerationupdown    =  125
+  >
+    <EffectContainer condition="idle">
+      <WorldSound mainstate="activity" source="sounds/Engine_idle.ogg" looping=1 active=false/>
+    </EffectContainer>
+    <EffectContainer condition="not idle">
+      <FadingBillboard mainstate=activity active=false scale=0.09 position="13, 0, 16" colour="0.2, 1.0, 0.65, 1.0" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
+      <FadingBillboard mainstate=activity active=false scale=0.09 position="-13, 0, 16" colour="0.2, 1.0, 0.65, 1.0" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
+    </EffectContainer>
+    <EffectContainer condition="normal or brake">
+
+    </EffectContainer>
+    <EffectContainer condition="normal or boost">
+      <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 0, 2, 16" colour="0.2, 1.0, 0.65, 1.0" width=25 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
+<Backlight mainstate=activity active=false scale=0.33 name=bltest position=" 13, 0, 16" colour="0.2, 1.0, 0.65, 1.0" width=20 length=1000
+ lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
+<Backlight mainstate=activity active=false scale=0.33 name=bltest position=" -13, 0, 16" colour="0.2, 1.0, 0.65, 1.0" width=20 length=1000 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
+    </EffectContainer>
+    <EffectContainer condition="boost">
+      <Backlight mainstate=activity active=false scale=0.33 name=bltest position=" 0, 2, 16" colour="0.6, 0.8, 0.75, 0.7" width=35 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
+    </EffectContainer>
+
+  </MultiStateEngine>
+</Template>